#include <stdlib.h>
#include <stdio.h>
#include <sched.h>


/* small demo-program to show linux-multithreading with clone. 
   Peter Ganten, 27.6.1999
   NOTE: Synchronization is just done by sleep() calls, usually
   one has to use mutexes and semaphores to achieve this */

/* global variable */
int a=0;

static void THREAD_Start ( int * arg ) {
  int i;

  /* Give the first thread time to flush stdout */
  sleep (1);

  printf ( "second thread is running, pid=%d.\n", getpid() );
  printf ( "arg is %d\n", *arg );
  /* Do all kind of wired multithreaded stuff */
  for ( i=0; i<10; i++ ) {
    sleep (1);
    printf ( "a = %d\n", a );
  }

  printf ( "exiting second thead.\n" );
  exit (0);
}

int main ( int argc, char * argv[] ) {
  size_t stacksize=1024*4;
  void * stack;
  int thread_arg=10;

  /* We have to do unbuffered file-io */
  // setvbuf ( stdout, (char *)NULL, _IONBF, 0 );

  printf ( "first thread is running, pid=%d.\n", getpid() );
  
  printf ( "setting up stack for the new thread..." );
  stack = malloc ( stacksize );
  if ( stack == NULL ) { printf ( "failed!\n" ); exit (1); }
  printf ( "done.\n" );

  printf ( "starting second thread..." );
  if ( __clone ( (int (*)(void *))THREAD_Start, stack + stacksize,
               CLONE_VM | CLONE_FS | CLONE_FILES, &thread_arg ) < 0 )
    { printf ( "failed!\n" ); free (stack); exit (1); }
  printf ( "done.\n" );

  sleep (6);
  a=10;
  sleep (6);
  
  printf ( "exiting first thead.\n" );
  exit (0);
}

